
/**************************************************************************************************
 *  Define Result Code
 *************************************************************************************************/
typedef NS_ENUM(NSInteger, SDK_RESULT_CODES) {
    SDK_RESULT_SUCCESS                     = 0x0000,
    SDK_RESULT_FAIL                        = 0xF000,
    SDK_RESULT_FAIL_NO_OPEN               ,
    SDK_RESULT_FAIL_OPEN_ALREADY          ,
    SDK_RESULT_FAIL_NO_CONNECT            ,
    SDK_RESULT_FAIL_CONNECT_ALREADY       ,
    SDK_RESULT_FAIL_WRITE_ERROR           ,
    SDK_RESULT_FAIL_READ_ERROR            ,
    SDK_RESULT_FAIL_INVALID_PARAMETER     ,
};

/////////////////////////////////////////////////////////////////////
// InterfaceType
/////////////////////////////////////////////////////////////////////
typedef NS_ENUM(NSInteger, SDK_INTERFACE_TYPE) {
    SDK_INTERFACE_TYPE_WIFI           = 1,
    SDK_INTERFACE_TYPE_ETHERNET       = 2,
    SDK_INTERFACE_TYPE_BLUETOOTH      = 4,
    SDK_INTERFACE_TYPE_BROADCAST      = 8,
    SDK_INTERFACE_TYPE_BLUETOOTH_BLE  = 10,
    
    
};
/**************************************************************************************************
 *  Define Alignment List
 *************************************************************************************************/
typedef NS_ENUM(NSInteger, SDK_ALIGNMENT) {
    SDK_ALIGNMENT_LEFT                     = 0,
    SDK_ALIGNMENT_RIGHT                    = 1,
    SDK_ALIGNMENT_CENTER                   = 2,    //  Device Text is not support
    SDK_ALIGNMENT_STRING_FROM_RIGHT_2_LEFT = 2,    //  Vector Text is not support
};


/**************************************************************************************************
 *  Define Barcode Text Postion and FontSize
 *************************************************************************************************/
typedef NS_ENUM(NSInteger, SDK_BARCODE_HRI) {
    SDK_BARCODE_HRI_NONE                     = 0,
    SDK_BARCODE_HRI_BELOW_FONTSIZE1          = 1,
    SDK_BARCODE_HRI_ABOVE_FONTSIZE1          = 2,
    SDK_BARCODE_HRI_BELOW_FONTSIZE2          = 3,
    SDK_BARCODE_HRI_ABOVE_FONTSIZE2          = 4,
    SDK_BARCODE_HRI_BELOW_FONTSIZE3          = 5,
    SDK_BARCODE_HRI_ABOVE_FONTSIZE3          = 6,
    SDK_BARCODE_HRI_BELOW_FONTSIZE4          = 7,
    SDK_BARCODE_HRI_ABOVE_FONTSIZE4          = 8,
};

/**************************************************************************************************
 *  Media Type  for parameter in 'setLength'
 *************************************************************************************************/
typedef NS_ENUM(char, SDK_MEDIA_TYPE) {
    SDK_MEDIA_TYPE_GAP                    = 'G',
    SDK_MEDIA_TYPE_CONTINUOUS             = 'C',
    SDK_MEDIA_TYPE_BLACK_MARK             = 'B',
};



/**************************************************************************************************
 *  Speed  for parameter in 'setSpeed'
 *************************************************************************************************/
typedef NS_ENUM(NSInteger, SDK_SPEED_VALUE) {
    SDK_SPEED_VALUE_1_0_IPS               = 1,
    SDK_SPEED_VALUE_2_0_IPS               = 2,
    SDK_SPEED_VALUE_3_0_IPS               = 3,
    SDK_SPEED_VALUE_4_0_IPS               = 4,
    SDK_SPEED_VALUE_5_0_IPS               = 5
};


/**************************************************************************************************
 *  Define Barcode Text Postion and FontSize
 *************************************************************************************************/
typedef NS_ENUM(NSInteger, SDK_BARCODE_TYPE) {
    SDK_BARCODE_TYPE_CODE39                   = 0,
    SDK_BARCODE_TYPE_CODE128                  = 1,
    SDK_BARCODE_TYPE_I2Of5                    = 2,
    SDK_BARCODE_TYPE_CODABAR                  = 3,
    SDK_BARCODE_TYPE_CODE93                   = 4,
    SDK_BARCODE_TYPE_UPC_A                    = 5,
    SDK_BARCODE_TYPE_UPC_E                    = 6,
    SDK_BARCODE_TYPE_EAN13                    = 7,
    SDK_BARCODE_TYPE_EAN8                     = 8,
    SDK_BARCODE_TYPE_EAN128                   = 9,
    SDK_BARCODE_TYPE_CODE11                   = 10,
    SDK_BARCODE_TYPE_PLANET                   = 11,
    SDK_BARCODE_TYPE_INDUSTRIAL_2Of5          = 12,
    SDK_BARCODE_TYPE_STANDARD_2Of5            = 13,
    SDK_BARCODE_TYPE_LOGMARS                  = 14,
    SDK_BARCODE_TYPE_UPC_EAN_EXTENSIONS       = 15,
    SDK_BARCODE_TYPE_POSTNET                  = 16,
};

/**************************************************************************************************
 *  Define MAXI CODE MODE
 *************************************************************************************************/
typedef NS_ENUM(NSInteger, SDK_MAXICODE_MODE) {
    SDK_MAXICODE_MODE_0                     = 0,
    SDK_MAXICODE_MODE_2                     = 2,
    SDK_MAXICODE_MODE_3                     = 3,
    SDK_MAXICODE_MODE_4                     = 4,
};

/**************************************************************************************************
 *  Define BARCODE Origin point
 *************************************************************************************************/
typedef NS_ENUM(NSInteger, SDK_BARCODE_ORIGIN_POINT) {
    SDK_BARCODE_ORIGIN_POINT_CENTER         = 0,
    SDK_BARCODE_ORIGIN_POINT_UPPER_LEFT      = 1,
};
/**************************************************************************************************
 *  Define Error Correction Level
 *************************************************************************************************/
typedef NS_ENUM(NSInteger, SDK_ERROR_CORRECTION_LEVEL) {
    SDK_ERROR_CORRECTION_LEVEL0           = 0,
    SDK_ERROR_CORRECTION_LEVEL1           = 1,
    SDK_ERROR_CORRECTION_LEVEL2           = 2,
    SDK_ERROR_CORRECTION_LEVEL3           = 3,
    SDK_ERROR_CORRECTION_LEVEL4           = 4,
    SDK_ERROR_CORRECTION_LEVEL5           = 5,
    SDK_ERROR_CORRECTION_LEVEL6           = 6,
    SDK_ERROR_CORRECTION_LEVEL7           = 7,
    SDK_ERROR_CORRECTION_LEVEL8           = 8,
};

/**************************************************************************************************
 *  Define Data Compression Method
 *************************************************************************************************/
typedef NS_ENUM(NSInteger, SDK_DATA_COMPRESSION_METHOD) {
    SDK_DATA_COMPRESSION_METHOD_TEXT       = 0,
    SDK_DATA_COMPRESSION_METHOD_NUMERIC    = 1,
    SDK_DATA_COMPRESSION_METHOD_BINARY     = 2,
};

/**************************************************************************************************
 *  Define QR CODE MODEL
 *************************************************************************************************/
typedef NS_ENUM(NSInteger, SDK_QRCODE_MODE) {
    SDK_QRCODE_MODEL_1                     = 1,
    SDK_QRCODE_MODEL_2                     = 2,
};

/**************************************************************************************************
 *  Define Code49 STARTING MODE
 *************************************************************************************************/
typedef NS_ENUM(NSInteger, SDK_STARTING_MODE) {
    SDK_STARTINGMODE_REGULAR_ALPHANUMERIC      = 0,
    SDK_STARTINGMODE_MULTIPLE_READ_ALPHANUMERIC= 1,
    SDK_STARTINGMODE_REGULAR_NUMERIC           = 2,
    SDK_STARTINGMODE_GROUP_ALPHANUMERIC        = 3,
    SDK_STARTINGMODE_REGULAR_ALPHANUMRIC_SHIFT1= 4,
    SDK_STARTINGMODE_REGULAR_ALPHANUMRIC_SHIFT2= 5,
    SDK_STARTINGMODE_AUTOMATIC                 = 7,
};


/**************************************************************************************************
 *  Define CODABLOCK MODE
 *************************************************************************************************/
typedef NS_ENUM(NSInteger, SDK_CODABLOCK_MODE) {
    SDK_CODABLOCK_MODE_A                   = 'A',
    SDK_CODABLOCK_MODE_E                   = 'E',
    SDK_CODABLOCK_MODE_F                   = 'F',
    
};


/**************************************************************************************************
 *  Define CHECK DIGIT OPTION
 *************************************************************************************************/
typedef NS_ENUM(NSInteger, SDK_CHECKDIGIT) {
    SDK_CHECKDIGIT_NONE                    = 0,
    SDK_CHECKDIGIT_1MOD10                  = 1,
    SDK_CHECKDIGIT_2MOD10                  = 2,
    SDK_CHECKDIGIT_1MOD11_AND_1MOD_10      = 3,
    
};


/**************************************************************************************************
 *  Define RSS Barcode Type
 *************************************************************************************************/
typedef NS_ENUM(NSInteger, SDK_RSS_BARCODE_TYPE) {
    SDK_RSS_BARCODE_TYPE_RSS14                = 0,
    SDK_RSS_BARCODE_TYPE_RSS14_TRUNCATED      = 1,
    SDK_RSS_BARCODE_TYPE_RSS14_STACKED        = 2,
    SDK_RSS_BARCODE_TYPE_RSS14_STACKED_OMNIDIRECTIONAL = 3,
    SDK_RSS_BARCODE_TYPE_RSS_LIMITED          = 4,
    SDK_RSS_BARCODE_TYPE_RSS_EXPANDED         = 5,
    SDK_RSS_BARCODE_TYPE_UPC_A                = 6,
    SDK_RSS_BARCODE_TYPE_UPC_E                = 7,
    SDK_RSS_BARCODE_TYPE_EAN13                = 8,
    SDK_RSS_BARCODE_TYPE_EAN8                 = 9,
    SDK_RSS_BARCODE_TYPE_UCC_EAN128_CC_A_B    = 10,
    SDK_RSS_BARCODE_TYPE_UCC_EAN128_CC_C      = 11,
    
};

/**************************************************************************************************
 *  Define Font Attributes List
 *************************************************************************************************/
typedef NS_ENUM(NSInteger, SDK_ROTATION_DEGREES){
    SDK_ROTATION_DEGREES_0                 = 0,
    SDK_ROTATION_DEGREES_90                = 1,
    SDK_ROTATION_DEGREES_180               = 2,
    SDK_ROTATION_DEGREES_270               = 3,
};

/**************************************************************************************************
 *  Define Orientation List
 *************************************************************************************************/
typedef NS_ENUM(NSInteger, SDK_ORIENTATION){
    SDK_ORIENTATION_TOP_BOTTOM             = 0,
    SDK_ORIENTATION_BOTTOM_TOP             = 1,
};



/**************************************************************************************************
 *  Define Device Fonts List
 *************************************************************************************************/
typedef NS_ENUM(char, SDK_DEVICE_FONT) {
    SDK_DEVICE_FONT_6PT                   ='0',         //    9 X 15 (dots)
    SDK_DEVICE_FONT_8PT                   ='1',         //   12 X 20 (dots)
    SDK_DEVICE_FONT_10PT                  ='2',         //   16 X 25 (dots)
    SDK_DEVICE_FONT_12PT                  ='3',         //   19 X 30 (dots)
    SDK_DEVICE_FONT_15PT                  ='4',         //   24 X 38 (dots)
    SDK_DEVICE_FONT_20PT                  ='5',         //   32 X 40 (dots)
    SDK_DEVICE_FONT_30PT                  ='6',         //   48 X 76 (dots)
    SDK_DEVICE_FONT_14PT                  ='7',         //   22 X 34 (dots)
    SDK_DEVICE_FONT_18PT                  ='8',         //   28 X 44 (dots)
    SDK_DEVICE_FONT_24PT                  ='9',         //   37 X 58 (dots)
    SDK_DEVICE_FONT_KOREAN1               ='a',         //   16 X 16 (dots)  (ascii  9 X 15)
    SDK_DEVICE_FONT_KOREAN2               ='b',         //   24 X 24 (dots)  (ascii 12 X 24)
    SDK_DEVICE_FONT_KOREAN3               ='c',         //   20 X 20 (dots)  (ascii 12 X 20)
    SDK_DEVICE_FONT_KOREAN4               ='d',         //   26 X 26 (dots)  (ascii 16 X 30)
    SDK_DEVICE_FONT_KOREAN5               ='e',         //   20 X 26 (dots)  (ascii 16 X 30)
    SDK_DEVICE_FONT_KOREAN6               ='f',         //   38 X 38 (dots)  (ascii 22 X 34)
    SDK_DEVICE_FONT_GB2312                ='m',         //   24 X 24 (dots)  (ascii 12 X 24)
    SDK_DEVICE_FONT_BIG5                  ='n',         //   24 X 24 (dots)  (ascii 12 X 24)
    SDK_DEVICE_FONT_SHIFT_JIS             ='j',         //   24 X 24 (dots)  (ascii 12 X 24)
};


/**************************************************************************************************
 *  Define Vector Fonts List
 *************************************************************************************************/
typedef NS_ENUM(char, SDK_VECTOR_FONT) {
    
    SDK_VECTOR_FONT_ASCII                  ='U',
    SDK_VECTOR_FONT_KS5601                 ='K',
    SDK_VECTOR_FONT_BIG5                   ='B',
    SDK_VECTOR_FONT_GB2312                 ='G',
    SDK_VECTOR_FONT_SHIFT_JIS              ='J',
    SDK_VECTOR_FONT_OCR_A                  ='a',
    SDK_VECTOR_FONT_OCR_B                  ='b',
    
};


/**************************************************************************************************
 *  Define Block draw options List
 *************************************************************************************************/
typedef NS_ENUM(char, SDK_DRAW_BLOCK_OPTION) {
    SDK_DRAW_BLOCK_OPTION_LINE_OVERWRITING ='O',
    SDK_DRAW_BLOCK_OPTION_LINE_EXCLUSIVE_OR='E',
    SDK_DRAW_BLOCK_OPTION_LINE_DELETE      ='D',
    SDK_DRAW_BLOCK_OPTION_SLOPE            ='S',
    SDK_DRAW_BLOCK_OPTION_BOX              ='B',
};


/**************************************************************************************************
 *  Define Circle sizes List
 *************************************************************************************************/
typedef NS_ENUM(NSInteger, SDK_DRAW_CIRCLE_SIZE) {
    SDK_DRAW_CIRCLE_SIZE_40X40             = 1,    //  5(mm) diameter
    SDK_DRAW_CIRCLE_SIZE_56X56             = 2,
    SDK_DRAW_CIRCLE_SIZE_72X72             = 3,
    SDK_DRAW_CIRCLE_SIZE_88X88             = 4,
    SDK_DRAW_CIRCLE_SIZE_104X104           = 5,
    SDK_DRAW_CIRCLE_SIZE_168X168           = 6,
};



/**************************************************************************************************
 *  Define International Character Set
 *************************************************************************************************/
typedef NS_ENUM(NSInteger, SDK_CONFIG_ICS) {
    SDK_CONFIG_ICS_USA                    = 0,
    SDK_CONFIG_ICS_FRANCE                 = 1,
    SDK_CONFIG_ICS_GERMANY                = 2,
    SDK_CONFIG_ICS_UK                     = 3,
    SDK_CONFIG_ICS_DENMARK_I              = 4,
    SDK_CONFIG_ICS_SWEDEN                 = 5,
    SDK_CONFIG_ICS_ITALY                  = 6,
    SDK_CONFIG_ICS_SPAIN_I                = 7,
    SDK_CONFIG_ICS_NORWAY                 = 8,
    SDK_CONFIG_ICS_DENMARK_II             = 9,
    SDK_CONFIG_ICS_JAPAN                  = 10,
    SDK_CONFIG_ICS_SPAIN_II               = 11,
    SDK_CONFIG_ICS_LATIN_AMERICA          = 12,
    SDK_CONFIG_ICS_KOREA                  = 13,
    SDK_CONFIG_ICS_SLOVENIA_CROATIA       = 14,
    SDK_CONFIG_ICS_CHINA                  = 15,
};

/**************************************************************************************************
 *  Define Code pages
 *************************************************************************************************/
typedef NS_ENUM(NSInteger, SDK_CONFIG_CODEPAGE) {
    SDK_CONFIG_CODEPAGE_CP437             = 0,
    SDK_CONFIG_CODEPAGE_CP850             = 1,
    SDK_CONFIG_CODEPAGE_CP852             = 2,
    SDK_CONFIG_CODEPAGE_CP860             = 3,
    SDK_CONFIG_CODEPAGE_CP863             = 4,
    SDK_CONFIG_CODEPAGE_CP865             = 5,
    SDK_CONFIG_CODEPAGE_CP1252            = 6,
    SDK_CONFIG_CODEPAGE_CP865_WCP1252     = 7,
    SDK_CONFIG_CODEPAGE_CP857             = 8,
    SDK_CONFIG_CODEPAGE_CP737             = 9,
    SDK_CONFIG_CODEPAGE_WCP1250           = 10,
    SDK_CONFIG_CODEPAGE_WCP1253           = 11,
    SDK_CONFIG_CODEPAGE_WCP1254           = 12,
    SDK_CONFIG_CODEPAGE_CP855             = 13,
    SDK_CONFIG_CODEPAGE_CP862             = 14,
    SDK_CONFIG_CODEPAGE_CP866             = 15,
    SDK_CONFIG_CODEPAGE_WCP1251           = 16,
    SDK_CONFIG_CODEPAGE_WCP1255           = 17,
    SDK_CONFIG_CODEPAGE_CP928             = 18,
    SDK_CONFIG_CODEPAGE_CP864             = 19,
    SDK_CONFIG_CODEPAGE_CP775             = 20,
    SDK_CONFIG_CODEPAGE_WCP1257           = 21,
    SDK_CONFIG_CODEPAGE_CP858             = 22,
};

/**************************************************************************************************
 *  Define Status
 *************************************************************************************************/
typedef NS_OPTIONS(NSInteger, SDK_STATUS) {
    SDK_STATUS_PRINTER_PAPEREMPTY          = 0x00000080,
    SDK_STATUS_PRINTER_COVEROPEN           = 0x00000040,
    SDK_STATUS_PRINTER_MOTOR_OVERHEAT      = 0x00000020,
    SDK_STATUS_PRINTER_TPH_OVERHEAT        = 0x00000010,
    SDK_STATUS_PRINTER_GAP_ERROR           = 0x00000008, //  Auto Detection Fail
    SDK_STATUS_PRINTER_BOARD_OVERHEAT      = 0x00000004,
    SDK_STATUS_PRINTER_WAIT_TAKEN          = 0x00000002,
    
    SDK_STATUS_PRINTER_BUILDING_LABEL      = 0x00008000,
    SDK_STATUS_PRINTER_PRINTING_LABEL      = 0x00004000,
    SDK_STATUS_PRINTER_ISSUED_LABEL        = 0x00002000
};

/**************************************************************************************************
 *  Define blocks type
 *************************************************************************************************/
typedef void (^blockType1)(NSInteger Parameter);

/**************************************************************************************************
 *  Define Widths
 *************************************************************************************************/
#define SDK_WIDTH_FULL         -1
