
#import "DrawBitmapViewController.h"

@interface DrawBitmapViewController () {
    LabelPrinterSDK *printer;
}

@end

@implementation DrawBitmapViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    printer = SharedLabelPrinterSDK.sharedInstance;
}

- (IBAction)print:(UIButton *)sender {
    UIImage *image = _ivImage.image;
    
    NSInteger xPos = _tfXpos.text.integerValue;
    NSInteger yPos = _tfYpos.text.integerValue;
    NSInteger width = image.size.width;
    BOOL dither = _segDither.selectedSegmentIndex == 1;

    SDK_RESULT_CODES result = [printer drawImageData:image
                                          stratPosX:xPos
                                          startPosY:yPos
                                              width:width
                                       useDithering:dither];

    if (result != SDK_RESULT_SUCCESS) {
        [self presentTextAlertWithTitle:nil msg:@"Draw Fail"];
        return;
    }
    
    result = [printer doPrint:1];
    if (result != SDK_RESULT_SUCCESS) {
        [self presentTextAlertWithTitle:nil msg:@"Print Fail"];
        return;
    }
}

@end
