
#import "DrawCircleViewController.h"

@interface DrawCircleViewController () {
    LabelPrinterSDK *printer;
    
    NSArray<NSString*>* sizeDescList;
    NSArray<NSNumber*>* sizeList;
    
    SDK_DRAW_CIRCLE_SIZE size;
}

@end

@implementation DrawCircleViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    printer = SharedLabelPrinterSDK.sharedInstance;
    sizeList = @[
        [NSNumber numberWithInt:SDK_DRAW_CIRCLE_SIZE_40X40],
        [NSNumber numberWithInt:SDK_DRAW_CIRCLE_SIZE_56X56],
        [NSNumber numberWithInt:SDK_DRAW_CIRCLE_SIZE_72X72],
        [NSNumber numberWithInt:SDK_DRAW_CIRCLE_SIZE_88X88],
        [NSNumber numberWithInt:SDK_DRAW_CIRCLE_SIZE_104X104],
        [NSNumber numberWithInt:SDK_DRAW_CIRCLE_SIZE_168X168]
    ];
    
    sizeDescList = @[
        @"40x40",
        @"56x56",
        @"72x72",
        @"88x88",
        @"104x104",
        @"168x168"
    ];
    
    [_btnSize setTitle:sizeDescList.firstObject forState:UIControlStateNormal];
    size = sizeList.firstObject.intValue;
}

- (IBAction)selectSize:(UIButton *)sender {
    UIAlertController *controller = [UIAlertController alertControllerWithTitle:nil
                                                                        message:nil
                                                                 preferredStyle:UIAlertControllerStyleAlert];
    
    for (NSInteger idx = 0; idx < sizeDescList.count; idx++) {
        [controller addAction:[UIAlertAction actionWithTitle:sizeDescList[idx]
                                                       style:UIAlertActionStyleDefault
                                                     handler:^(UIAlertAction * _Nonnull action) {
            [self->_btnSize setTitle:self->sizeDescList[idx]
                                 forState:UIControlStateNormal];
            self->size = self->sizeList[idx].intValue;
        }]];
    }
    
    [controller addAction:[UIAlertAction actionWithTitle:@"Cancel"
                                                   style:UIAlertActionStyleCancel
                                                 handler:nil]];
    [self presentViewController:controller animated:YES completion:nil];
}

- (IBAction)print:(UIButton*)sender {
    NSInteger xPos = _tfXpos.text.integerValue;
    NSInteger yPos = _tfYpos.text.integerValue;
    NSInteger multiplier = _tfMultiplier.text.integerValue;
    
    SDK_RESULT_CODES result = [printer drawCircle:xPos
                                           startPosY:yPos
                                       sizeSelection:size
                                          multiplier:multiplier];
    if (result != SDK_RESULT_SUCCESS) {
        [self presentTextAlertWithTitle:nil msg:@"Draw Fail"];
        return;
    }
    
    result = [printer doPrint:1];
    if (result !=SDK_RESULT_SUCCESS) {
        [self presentTextAlertWithTitle:nil msg:@"Print Fail"];
        return;
    }
}

@end
