
#import "DrawDataMatrixViewController.h"

@interface DrawDataMatrixViewController () {
    LabelPrinterSDK* printer;
}

@end

@implementation DrawDataMatrixViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    printer = SharedLabelPrinterSDK.sharedInstance;
}

-(IBAction)print:(UIButton* )sender {
    NSString *text= _tfText.text;
    NSInteger xPos = _tfXpos.text.integerValue;
    NSInteger yPos = _tfYpos.text.integerValue;
    NSInteger size = _tfSize.text.integerValue;
    
    NSInteger rotation = SDK_ROTATION_DEGREES_0;
    switch (_segRotation.selectedSegmentIndex) {
        case 0: rotation = SDK_ROTATION_DEGREES_0; break;
        case 1: rotation = SDK_ROTATION_DEGREES_90; break;
        case 2: rotation = SDK_ROTATION_DEGREES_180; break;
        case 3: rotation = SDK_ROTATION_DEGREES_270; break;
        default:
            rotation = SDK_ROTATION_DEGREES_0;
            break;
    }
    
    SDK_RESULT_CODES result = [printer drawBarcodeDataMatrix:text
                                                      xPosition:xPos
                                                      yPosition:yPos
                                                    barcodeSize:size
                                                        reverse:NO
                                                       rotation:rotation];
    
    if (result != SDK_RESULT_SUCCESS) {
        [self presentTextAlertWithTitle:nil msg:@"Draw Fail"];
        return;
    }
    
    result = [printer doPrint:1];
    if (result != SDK_RESULT_SUCCESS) {
        [self presentTextAlertWithTitle:nil msg:@"Print Fail"];
        return;
    }
}

@end
