
#import "DrawMaxiCodeViewController.h"

@interface DrawMaxiCodeViewController () {
    LabelPrinterSDK *printer;
    NSArray<NSNumber *>* modeList;
    NSArray<NSString *>* modeDescList;
    
    SDK_MAXICODE_MODE mode;
}

@end

@implementation DrawMaxiCodeViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    printer = SharedLabelPrinterSDK.sharedInstance;
    modeList = @[
        [NSNumber numberWithInt:SDK_MAXICODE_MODE_0],
        [NSNumber numberWithInt:SDK_MAXICODE_MODE_2],
        [NSNumber numberWithInt:SDK_MAXICODE_MODE_3],
        [NSNumber numberWithInt:SDK_MAXICODE_MODE_4]
    ];
    
    modeDescList = @[
        @"Mode 0",
        @"Mode 2",
        @"Mode 3",
        @"Mode 4"
    ];
    
    [_btnMode setTitle:modeDescList.firstObject forState:UIControlStateNormal];
    mode = modeList.firstObject.integerValue;
}

- (IBAction)selectMode:(UIButton *)sender {
    UIAlertController *controller = [UIAlertController alertControllerWithTitle:nil
                                                                        message:nil
                                                                 preferredStyle:UIAlertControllerStyleAlert];
    
    for (NSInteger idx = 0; idx < modeDescList.count; idx++) {
        [controller addAction:[UIAlertAction actionWithTitle:modeDescList[idx]
                                                       style:UIAlertActionStyleDefault
                                                     handler:^(UIAlertAction * _Nonnull action) {
            [self->_btnMode setTitle:self->modeDescList[idx]
                                 forState:UIControlStateNormal];
            self->mode = self->modeList[idx].integerValue;
        }]];
    }
    
    [controller addAction:[UIAlertAction actionWithTitle:@"Cancel"
                                                   style:UIAlertActionStyleCancel
                                                 handler:nil]];
    [self presentViewController:controller animated:YES completion:nil];
}

- (IBAction)print:(UIButton*)sender {
    NSString *text = _tfText.text;
    NSInteger xPos = _tfXpos.text.integerValue;
    NSInteger yPos = _tfYpos.text.integerValue;

    SDK_RESULT_CODES result = [printer drawBarcodeMaxiCode:text
                                                xPosition:xPos
                                                yPosition:yPos
                                                     mode:mode];

    if (result != SDK_RESULT_SUCCESS) {
        [self presentTextAlertWithTitle:nil msg:@"Draw Fail"];
        return;
    }
    
    result = [printer doPrint:1];
    if (result != SDK_RESULT_SUCCESS) {
        [self presentTextAlertWithTitle:nil msg:@"Print Fail"];
        return;
    }
}

@end
