
#import "GetStatusViewController.h"

@interface GetStatusViewController () {
    LabelPrinterSDK *printer;
}

@end

@implementation GetStatusViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    printer = [SharedLabelPrinterSDK sharedInstance];
}

- (IBAction)onClear:(UIButton *)sender {
    _tvHistory.text = @"";
}

- (IBAction)getStatus:(UIButton *)sender {
    SDK_RESULT_CODES result = [printer checkPrinterStatus:^(NSInteger status) {
        NSString *strStatus = nil;
        
        if (status < 0) {
            strStatus = @"Data Receive Error";
        } else if ((status & SDK_STATUS_PRINTER_PAPEREMPTY) == SDK_STATUS_PRINTER_PAPEREMPTY) {
            strStatus = @"Paper Empty";
        } else if ((status & SDK_STATUS_PRINTER_COVEROPEN) == SDK_STATUS_PRINTER_COVEROPEN) {
            strStatus = @"Cover Open";
        } else if ((status & SDK_STATUS_PRINTER_MOTOR_OVERHEAT) == SDK_STATUS_PRINTER_MOTOR_OVERHEAT) {
            strStatus = @"Motor OverHeat";
        } else if ((status & SDK_STATUS_PRINTER_TPH_OVERHEAT) == SDK_STATUS_PRINTER_TPH_OVERHEAT) {
            strStatus = @"TPH OverHeat";
        } else if ((status & SDK_STATUS_PRINTER_GAP_ERROR) == SDK_STATUS_PRINTER_GAP_ERROR) {
            strStatus = @"Gap Error";
        } else if ((status & SDK_STATUS_PRINTER_BOARD_OVERHEAT) == SDK_STATUS_PRINTER_BOARD_OVERHEAT) {
            strStatus = @"Board OverHeat";
        } else if ((status & SDK_STATUS_PRINTER_WAIT_TAKEN) == SDK_STATUS_PRINTER_WAIT_TAKEN) {
            strStatus = @"Wait Taken";
        } else if ((status & SDK_STATUS_PRINTER_BUILDING_LABEL) == SDK_STATUS_PRINTER_BUILDING_LABEL) {
            strStatus = @"Building Label";
        } else if ((status & SDK_STATUS_PRINTER_PRINTING_LABEL) == SDK_STATUS_PRINTER_PRINTING_LABEL) {
            strStatus = @"Printing Label";
        } else if ((status & SDK_STATUS_PRINTER_ISSUED_LABEL) == SDK_STATUS_PRINTER_ISSUED_LABEL) {
            strStatus = @"Issued Label";
        } else {
            strStatus = @"Normal";
        }
        
        [self addHistoryWithText:strStatus];
    }];
    
    if (result == SDK_RESULT_SUCCESS) {
        [self addHistoryWithText:@"Success request check printer status."];
    } else {
        [self addHistoryWithText:@"Fail request check printer status."];
    }
}

- (void) addHistoryWithText:(NSString *)text {
    _tvHistory.text = [_tvHistory.text stringByAppendingString:[text stringByAppendingString:@"\r\n"]];
    [_tvHistory scrollRangeToVisible:NSMakeRange(_tvHistory.text.length - 1, 1)];
}

@end
