
#import "SetLengthViewController.h"

@interface SetLengthViewController (){
    LabelPrinterSDK *printer;
    
    NSArray<NSString *>* mediaTypeDescList;
    NSArray<NSNumber *>* mediaTypeList;
    
    SDK_MEDIA_TYPE mediaType;
}

@end

@implementation SetLengthViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    printer = SharedLabelPrinterSDK.sharedInstance;
    
    mediaTypeDescList = @[
        @"Gap", @"Black mark", @"Continous"
    ];
    
    mediaTypeList = @[
        [NSNumber numberWithChar:SDK_MEDIA_TYPE_GAP],
        [NSNumber numberWithChar:SDK_MEDIA_TYPE_BLACK_MARK],
        [NSNumber numberWithChar:SDK_MEDIA_TYPE_CONTINUOUS]
    ];
    
    mediaType = mediaTypeList.firstObject.charValue;
    [_btnType setTitle:mediaTypeDescList.firstObject forState:UIControlStateNormal];
}

- (IBAction)setType:(UIButton *)sender {
    UIAlertController *controller = [UIAlertController alertControllerWithTitle:nil
                                                                        message:nil
                                                                 preferredStyle:UIAlertControllerStyleAlert];
    
    for (NSInteger idx = 0; idx < mediaTypeDescList.count; idx++) {
        [controller addAction:[UIAlertAction actionWithTitle:mediaTypeDescList[idx]
                                                       style:UIAlertActionStyleDefault
                                                     handler:^(UIAlertAction * _Nonnull action) {
            [self->_btnType setTitle:self->mediaTypeDescList[idx]
                                 forState:UIControlStateNormal];
            self->mediaType = [self->mediaTypeList[idx] charValue];
        }]];
    }
    
    [controller addAction:[UIAlertAction actionWithTitle:@"Cancel"
                                                   style:UIAlertActionStyleCancel
                                                 handler:nil]];
    [self presentViewController:controller animated:YES completion:nil];
}

- (IBAction)acceptSetting:(UIButton *)sender {
    
    NSInteger length = [_tfLabelLength.text integerValue];
    NSInteger gapLength = [_tfGapLength.text integerValue];
    NSInteger offsetLength = [_tfOffsetLength.text integerValue];
    
    SDK_RESULT_CODES result = [printer setLength:length
                                       gapLength:gapLength
                                       mediaType:mediaType
                                    offsetLength:offsetLength];
    
    if (result != SDK_RESULT_SUCCESS) {
        [self presentTextAlertWithTitle:nil msg:@"Fail"];
        return;
    }
}

@end
