
#import "SetOrientationViewController.h"

@interface SetOrientationViewController () {
    LabelPrinterSDK* printer;
    NSArray<NSString *>* orientationDesc;
    NSArray<NSNumber *>* orientations;
    SDK_ORIENTATION orientation;
}

@end

@implementation SetOrientationViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    printer = [SharedLabelPrinterSDK sharedInstance];
    orientationDesc = @[
        @"Top to bottom", @"Bottom to top"
    ];
    orientations = @[
        [NSNumber numberWithInt:SDK_ORIENTATION_TOP_BOTTOM],
        [NSNumber numberWithInt:SDK_ORIENTATION_BOTTOM_TOP]
    ];
    
    orientation = SDK_ORIENTATION_TOP_BOTTOM;
    [_btnOrientation setTitle:[orientationDesc firstObject] forState:UIControlStateNormal];
}

- (IBAction) setType:(UIButton *)sender {
    UIAlertController *controller = [UIAlertController alertControllerWithTitle:nil
                                                                        message:nil
                                                                 preferredStyle:UIAlertControllerStyleAlert];
    
    for (NSInteger idx = 0; idx < orientationDesc.count; idx++) {
        [controller addAction:[UIAlertAction actionWithTitle:orientationDesc[idx]
                                                       style:UIAlertActionStyleDefault
                                                     handler:^(UIAlertAction * _Nonnull action) {
            [self->_btnOrientation setTitle:self->orientationDesc[idx]
                                 forState:UIControlStateNormal];
            self->orientation = [self->orientations[idx] intValue];
        }]];
    }
    
    [controller addAction:[UIAlertAction actionWithTitle:@"Cancel"
                                                   style:UIAlertActionStyleCancel
                                                 handler:nil]];
    [self presentViewController:controller animated:YES completion:nil];
}

- (IBAction)acceptSetting:(UIButton *)sender {
    SDK_RESULT_CODES result = [printer setOrientation:orientation];
    if (result != SDK_RESULT_SUCCESS) {
        [self presentTextAlertWithTitle:nil msg:@"Fail"];
        return;
    }
}

@end
