
#import "SetSpeedViewController.h"

@interface SetSpeedViewController () {
    LabelPrinterSDK *printer;
    NSArray<NSString *>* speedDescList;
    NSArray<NSNumber *>* speedList;
    SDK_SPEED_VALUE speed;
}

@end

@implementation SetSpeedViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    printer = SharedLabelPrinterSDK.sharedInstance;
    speedDescList = @[
        @"1 IPS",
        @"2 IPS",
        @"3 IPS",
        @"4 IPS",
        @"5 IPS"
    ];
    
    speedList = @[
        [NSNumber numberWithInt:SDK_SPEED_VALUE_1_0_IPS],
        [NSNumber numberWithInt:SDK_SPEED_VALUE_2_0_IPS],
        [NSNumber numberWithInt:SDK_SPEED_VALUE_3_0_IPS],
        [NSNumber numberWithInt:SDK_SPEED_VALUE_4_0_IPS],
        [NSNumber numberWithInt:SDK_SPEED_VALUE_5_0_IPS]
    ];
    
    speed = speedList.firstObject.intValue;
    
    [_btnSpeed setTitle:speedDescList.firstObject forState:UIControlStateNormal];
}

- (IBAction)setSpeed:(UIButton *)sender {
    UIAlertController *controller = [UIAlertController alertControllerWithTitle:nil
                                                                        message:nil
                                                                 preferredStyle:UIAlertControllerStyleAlert];
    
    for (NSInteger idx = 0; idx < speedDescList.count; idx++) {
        [controller addAction:[UIAlertAction actionWithTitle:speedDescList[idx]
                                                       style:UIAlertActionStyleDefault
                                                     handler:^(UIAlertAction * _Nonnull action) {
            [self->_btnSpeed setTitle:self->speedDescList[idx]
                                 forState:UIControlStateNormal];
            self->speed = [self->speedList[idx] intValue];
        }]];
    }
    
    [controller addAction:[UIAlertAction actionWithTitle:@"Cancel"
                                                   style:UIAlertActionStyleCancel
                                                 handler:nil]];
    [self presentViewController:controller animated:YES completion:nil];
}

- (IBAction)acceptSetting:(UIButton *)sender {
    SDK_RESULT_CODES result = [printer setSpeed:speed];
    if (result != SDK_RESULT_SUCCESS) {
        [self presentTextAlertWithTitle:nil msg:@"Fail"];
        return;
    }
}

@end
