
import UIKit

class DrawBitmapViewController: BaseViewController {
    
    let printer = SharedLabelPrinterSDK.sdk
    
    @IBOutlet weak var ivImage:UIImageView!
    @IBOutlet weak var tfXpos:UITextField!
    @IBOutlet weak var tfYpos:UITextField!
    @IBOutlet weak var segDither:UISegmentedControl!
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
    }
    
    @IBAction func print(_ sender:UIButton) {
        guard let image = ivImage.image else {
            return
        }
        
        let xPos = Int(tfXpos.text ?? "0") ?? 0
        let yPos = Int(tfYpos.text ?? "0") ?? 0
        let width = Int(image.size.width)
        let dither = segDither.selectedSegmentIndex == 1

        var result = printer.drawImageData(image,
                                          stratPosX: xPos,
                                          startPosY: yPos,
                                          width: width,
                                          useDithering: dither)
        
        guard result == .SUCCESS else {
            presentTextAlert(msg: "Draw Fail")
            return
        }

        result = printer.doPrint(1)
        guard result == .SUCCESS else {
            presentTextAlert(msg: "Print Fail")
            return
        }
    }
}
