
import UIKit

class GetStatusViewController: BaseViewController {

    let printer = SharedLabelPrinterSDK.sdk
    
    @IBOutlet weak var tvHistory:UITextView!
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
    }
    
    @IBAction func onClear(_ sender: UIButton) {
        tvHistory.text = ""
    }
    
    @IBAction func getStatus(_ sender: UIButton) {
        let result = printer.checkPrinterStatus { [weak self] (status) in
            let strStatus:String
            let stat = SDK_STATUS(rawValue: status)
            
            if (stat.rawValue < 0) {
                strStatus = "Data Receive Error";
            } else if stat.contains(.PRINTER_PAPEREMPTY) {
                strStatus = "Paper Empty"
            } else if stat.contains(.PRINTER_COVEROPEN) {
                strStatus = "Cover Open"
            } else if stat.contains(.PRINTER_MOTOR_OVERHEAT) {
                strStatus = "Motter OverHeat"
            } else if stat.contains(.PRINTER_TPH_OVERHEAT) {
                strStatus = "TPH OverHeat"
            } else if stat.contains(.PRINTER_GAP_ERROR) {
                strStatus = "Gap Error"
            } else if stat.contains(.PRINTER_BOARD_OVERHEAT) {
                strStatus = "Board OverHeat"
            } else if stat.contains(.PRINTER_BUILDING_LABEL) {
                strStatus = "Building Label"
            } else if stat.contains(.PRINTER_PRINTING_LABEL) {
                strStatus = "Printing Label"
            } else if stat.contains(.PRINTER_ISSUED_LABEL) {
                strStatus = "Issued Label"
            } else if stat.contains(.PRINTER_WAIT_TAKEN) {
                strStatus = "Wait Taken"
            } else {
                strStatus = "Normal"
            }

            self?.addHistory(text: strStatus)
        }
        
        if result != .SUCCESS {
            addHistory(text: "Fail request check printer status.")
        } else {
            addHistory(text: "Success request check printer status.")
        }
    }
    
    func addHistory(text:String) {
        tvHistory.text = tvHistory.text.appending(text.appending("\r\n"))
    }
}
