
import UIKit

class SetLengthViewController: BaseViewController {

    let printer = SharedLabelPrinterSDK.sdk
    
    let mediaTypeList:[(value:SDK_MEDIA_TYPE, description:String)] = [
        (.GAP, "Gap"),
        (.BLACK_MARK, "Black mark"),
        (.CONTINUOUS, "Continous")
    ]
    
    @IBOutlet weak var btnType:UIButton!
    
    @IBOutlet weak var tfLabelLength:UITextField!
    @IBOutlet weak var tfGapLength:UITextField!
    @IBOutlet weak var tfOffsetLength:UITextField!
    
    lazy var currentType = mediaTypeList.first
    
    override func viewDidLoad() {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
        btnType.setTitle(currentType?.description, for: .normal)
    }
    
    @IBAction func setType(_ sener:UIButton) {
        let controller = UIAlertController(title: nil, message: nil, preferredStyle: .actionSheet)
        for type in mediaTypeList {
            controller.addAction(.init(title: type.description, style: .default, handler: { [weak self] _ in
                self?.btnType.setTitle(type.description, for: .normal)
                self?.currentType = type
            }))
        }
        controller.addAction(.init(title: "Cancel", style: .cancel, handler: nil))
        present(controller, animated: true, completion: nil)
    }
    
    @IBAction func acceptSetting(_ sender:UIButton) {
        
        let labelLength = Int(tfLabelLength.text ?? "0") ?? 0
        let gapLength = Int(tfGapLength.text ?? "0") ?? 0
        let offsetLength = Int(tfOffsetLength.text ?? "0") ?? 0
        
        let type = (currentType?.value ?? .GAP).rawValue
        
        let result = printer.setLength(labelLength,
                          gapLength: gapLength,
                          mediaType: type,
                          offsetLength: offsetLength)
        
        guard result == .SUCCESS else {
            presentTextAlert(msg: "Fail")
            return
        }
    }

}
