
import UIKit

class SetOrientationViewController: BaseViewController {
    
    let printer = SharedLabelPrinterSDK.sdk
    
    let orientationList:[(value:SDK_ORIENTATION, description:String)] = [
        (.TOP_BOTTOM, "Top to bottom"),
        (.BOTTOM_TOP, "Bottom to top")
    ]
    
    @IBOutlet weak var btnOrientation:UIButton!

    lazy var currentOrientation = orientationList.first
    
    override func viewDidLoad() {
        super.viewDidLoad()

        btnOrientation.setTitle(currentOrientation?.description, for: .normal)
    }
    
    @IBAction func setType(_ sender:UIButton) {
        let controller = UIAlertController(title: nil, message: nil, preferredStyle: .actionSheet)
        for orientation in orientationList {
            controller.addAction(.init(title: orientation.description, style: .default, handler: { [weak self] _ in
                self?.btnOrientation.setTitle(orientation.description, for: .normal)
                self?.currentOrientation = orientation
            }))
        }
        controller.addAction(.init(title: "Cancel", style: .cancel, handler: nil))
        present(controller, animated: true, completion: nil)
    }
    
    @IBAction func acceptSetting(_ sender:UIButton){
        let orientation = Int((currentOrientation?.value ?? SDK_ORIENTATION.TOP_BOTTOM).rawValue)

        let result = printer.setOrientation(orientation)
        
        guard result == .SUCCESS else {
            presentTextAlert(msg: "Fail")
            return
        }
    }
}
