

import UIKit

class SetSpeedViewController: BaseViewController {
    
    let printer = SharedLabelPrinterSDK.sdk
    
    let speedList:[(value:SDK_SPEED_VALUE, description:String)] = [
        (._1_0_IPS, "1 IPS"),
        (._2_0_IPS, "2 IPS"),
        (._3_0_IPS, "3 IPS"),
        (._4_0_IPS, "4 IPS"),
        (._5_0_IPS, "5 IPS")
    ]
    
    @IBOutlet weak var btnSpeed:UIButton!
    
    lazy var currentSpeed = speedList.first
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
        btnSpeed.setTitle(currentSpeed?.description, for: .normal)
    }
    
    @IBAction func setSpeed(_ sener:UIButton) {
        let controller = UIAlertController(title: nil, message: nil, preferredStyle: .actionSheet)
        for speed in speedList {
            controller.addAction(.init(title: speed.description, style: .default, handler: { [weak self] _ in
                self?.btnSpeed.setTitle(speed.description, for: .normal)
                self?.currentSpeed = speed
            }))
        }
        controller.addAction(.init(title: "Cancel", style: .cancel, handler: nil))
        present(controller, animated: true, completion: nil)
    }
    
    @IBAction func acceptSetting(_ sender:UIButton) {
        
        let speed = (currentSpeed?.value ?? ._1_0_IPS).rawValue
        
        let result = printer.setSpeed(speed)
        guard result == .SUCCESS else {
            presentTextAlert(msg: "Fail")
            return
        }
    }
}
